package com.mints.goodmoney.ui.activitys

import android.app.Dialog
import android.os.Bundle
import android.view.View
import com.bumptech.glide.Glide
import com.mints.goodmoney.R
import com.mints.goodmoney.common.Constant
import com.mints.goodmoney.mvp.model.ShaiziBean
import com.mints.goodmoney.mvp.presenters.ShaiziPresenter
import com.mints.goodmoney.mvp.views.ShaiziView
import com.mints.goodmoney.ui.activitys.base.BaseActivity
import com.mints.goodmoney.ui.widgets.dialog.DialogListener
import com.mints.goodmoney.ui.widgets.dialog.DialogUtils
import com.mints.goodmoney.utils.SpanUtils
import kotlinx.android.synthetic.main.activity_shaizi.*
import java.util.*

class ShaiziActivity : BaseActivity(), View.OnClickListener, ShaiziView {

    private var count: Int = 0
    private var diceId: Long? = null
    private var moneys: Double = 0.0
    private val shaiziPresenter by lazy { ShaiziPresenter() }
    private var starttime: Long? = null
    private var shaiziFlag: Int = 0 // 骰子大小  0-小 1-
    private var dialog: Dialog? = null


    override fun getContentViewLayoutID() = R.layout.activity_shaizi

    override fun isApplyKitKatTranslucency() = false

    override fun initViewsAndEvents() {
        shaiziPresenter.attachView(this)

        var spannable = SpanUtils().append("       猜骰子投掷数字为大还是小，1/2/3/为小，4/5/6为大，猜中时本次提现获得")
                .append("双倍收益")
                .setBold()
                .append("（奖励以金币形式发放），若没有猜中则本次提现金币回收。")
                .create()
        tv2.text = spannable

        initListener()
    }

    override fun onResume() {
        super.onResume()
    }

    override fun onPause() {
        super.onPause()
    }

    override fun onDestroy() {
        //关闭 接口绑定
        shaiziPresenter.detachView()
        super.onDestroy()
    }

    override fun onClick(v: View) {
        when (v.id) {
            R.id.shaiziback -> {
                finish()
            }
            R.id.btn_big -> {
                starttime = System.currentTimeMillis()
                shaiziPresenter.getRollDiceMsg(moneys, true)
                shaiziFlag = 1
            }
            R.id.btn_small -> {
                starttime = System.currentTimeMillis()
                shaiziPresenter.getRollDiceMsg(moneys, false)
            }
        }
    }

    fun startShaizi(time: Long, success: Int) {
        Glide.with(context).asGif().load(R.drawable.shaizi).into(iv_saizi);
        val timer = Timer()
        val task: TimerTask = object : TimerTask() {
            override fun run() {
                runOnUiThread {
                    when (count) {
                        1 -> Glide.with(context).load(R.mipmap.iv_tx_sz1).into(iv_saizi);
                        2 -> Glide.with(context).load(R.mipmap.iv_tx_sz2).into(iv_saizi);
                        3 -> Glide.with(context).load(R.mipmap.iv_tx_sz3).into(iv_saizi);
                        4 -> Glide.with(context).load(R.mipmap.iv_tx_sz4).into(iv_saizi);
                        5 -> Glide.with(context).load(R.mipmap.iv_tx_sz5).into(iv_saizi);
                        6 -> Glide.with(context).load(R.mipmap.iv_tx_sz6).into(iv_saizi);
                    }

                    if(success==1){
                        if(shaiziFlag==1) showresultDialog("恭喜您！", "本次开奖结果为大，您的收益已翻倍！",true)//猜的是大
                        else showresultDialog("恭喜您！", "本次开奖结果为小，您的收益已翻倍！",true)//猜的是小
                    } else {
                        if (shaiziFlag===1) showresultDialog("很遗憾！", "本次开奖结果为小，您未中奖，金币已收回。",false)
                        else showresultDialog("很遗憾！", "本次开奖结果为大，您未中奖，金币已收回。",false)
                    }
//                    if (shaiziFlag == 1) {
//                        if (count >= 4) {
//                            showresultDialog("恭喜您！", "本次开奖结果为大，您的收益已翻倍！", true)
//                        } else {
//                            showresultDialog("很遗憾！", "本次开奖结果为小，您未中奖，金币已收回。",false)
//                        }
//                    } else {
//                        if (count <= 3) {
//                            showresultDialog("恭喜您！", "本次开奖结果为小，您的收益已翻倍！",true)
//                        } else {
//                            showresultDialog("很遗憾！", "本次开奖结果为大，您未中奖，金币已收回。",false)
//                        }
//                    }
                }
            }
        }
        timer.schedule(task, (time!! - starttime!!) + 2000)
    }

    /**
     * 展示 骰子结果 弹框
     */
    private fun showresultDialog(s: String, s1: String, b: Boolean) {
        DialogUtils.showWinDialog(this@ShaiziActivity, s, s1, object : DialogListener() {
            override fun onClick(mydialog: Dialog?, v: View?) {
                when (v?.id) {
                    R.id.tv_know -> {
                        //向服务器传递 提现金额 骰子Id

                        if (b){
                            mydialog?.dismiss()
                            shaiziPresenter.saveTerminalInfo(moneys, diceId!!)
                        } else{
                            mydialog?.dismiss()
                            finish()
                        }
//                        dialog = mydialog
                    }
                }
            }
        })
    }

    /**
     * 获取 提现金额
     */
    override fun getBundleExtras(extras: Bundle) {
        super.getBundleExtras(extras)
        moneys = extras.getDouble(Constant.MONEY_KEY)
    }


    private fun initListener() {
        shaiziback.setOnClickListener(this)
        btn_small.setOnClickListener(this)
        btn_big.setOnClickListener(this)
    }


    /**
     * 请求成功
     */
    override fun getShaiziMsgHomeSuc(data: ShaiziBean) {
        //设置按钮 不可点击
        setButtonstatus(false)
        //更改按钮 背景
        if (shaiziFlag == 1) {
            btn_big.setBackgroundResource(R.mipmap.btn_tx_down)
        } else {
            btn_small.setBackgroundResource(R.mipmap.btn_tx_down_small)
        }
        //获取骰子 点数、Id
        count = data.randomPoint
        diceId = data.diceId

        //执行延时，旋转骰子，显示结果
        startShaizi(System.currentTimeMillis(), data.success)
    }

    /**
     * 设置按钮状态（可否点击）
     */
    private fun setButtonstatus(b: Boolean) {
        btn_small.isEnabled = b
        btn_big.isEnabled = b
    }

    /**
     * 请求失败
     */
    override fun getShaiziMsgHomefail() {
        //设置按钮 可点击
        setButtonstatus(true)
        //改变按钮 背景
        if (shaiziFlag == 1) {
            btn_big.setBackgroundResource(R.mipmap.btn_tx_up)
        } else {
            btn_small.setBackgroundResource(R.mipmap.btn_tx_up_small)
        }
    }

    override fun drawCashSuc() {
        finish()
    }

}


