package com.mints.goodmoney.ui.widgets.dialog

import android.app.Dialog
import android.content.Context
import android.view.Gravity
import android.view.KeyEvent
import android.view.WindowManager
import android.widget.ImageView
import android.widget.TextView
import com.mints.goodmoney.R

class TxDialog(context: Context, private val listener: DialogListener) :
        Dialog(context, R.style.dialog_two) {
    private val lp: WindowManager.LayoutParams

    private val iv_Close: ImageView
    private val tv_cash: TextView
    private val tv_double: TextView

    init {
        setContentView(R.layout.dialog_tx)
        // 设置window属性
        lp = window!!.attributes
        lp.gravity = Gravity.CENTER
        lp.width = WindowManager.LayoutParams.WRAP_CONTENT
        lp.windowAnimations = R.style.DialogAnimBottom
        window!!.attributes = lp

        // 设置外部不可关闭
        setCancelable(false)
        setCanceledOnTouchOutside(false)
        setOnKeyListener { _, i, _ ->
            i == KeyEvent.KEYCODE_BACK
        }
        // 查找View
        tv_cash = findViewById(R.id.tv_cash)
        tv_double = findViewById(R.id.tv_double)
        iv_Close = findViewById(R.id.iv_Close)
        //设置文字底部下划线，不同android系统显示效果不同，未使用
//        tv_subscribe.paint.setFlags(Paint.UNDERLINE_TEXT_FLAG)
//        tv_subscribe.paint.setAntiAlias(true)//抗锯齿

        tv_cash.setOnClickListener(listener)
        tv_double.setOnClickListener(listener)
        iv_Close.setOnClickListener(listener)
    }
}